package org.xbib.jdbc.connection.pool.util;

import java.util.concurrent.ThreadFactory;

public class DefaultThreadFactory implements ThreadFactory {

    private final String threadName;

    private final ClassLoader contextClassLoader;

    private final boolean daemon;

    public DefaultThreadFactory(String threadName,
                                ClassLoader contextClassLoader,
                                boolean daemon) {
        this.threadName = threadName;
        this.contextClassLoader = contextClassLoader;
        this.daemon = daemon;
    }

    @Override
    public Thread newThread(Runnable r) {
        Thread thread = new Thread(r, threadName);
        thread.setDaemon(daemon);
        thread.setContextClassLoader(contextClassLoader);
        return thread;
    }
}
